<?
/**
* ⥸塼륰դץ
*
* PHP version 5
*
* @package    procedures
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/
require_once( 'core/ClassLoader.class.php' );

class charcoal_ModuleGraphProcedure implements charcoal_IProcedure
{
	var $_input_filters;
	var $_output_filters;
	var $_class_loaders;
	var $_renderer;

	/*
	 * 󥹥ȥ饯
	 */
	public function __construct()
	{
	}

	/*
	 * ץ̾
	 */
	public function getProcedureName()
	{
		return "Module Graph Procedure";
	}

	/*
	 * ץ
	 */
	public function init( charcoal_Config $config )
	{
		$this->_output_filters      = $config->getArray( "output_filters" );
		$this->_input_filters       = $config->getArray( "input_filters" );
		$this->_renderer            = $config->getString( "renderer" );
	}

	/*
	 * ץ¹Ԥ
	 */
	public function execute( charcoal_Request $request, charcoal_ProcedureContext $context, charcoal_Response $response )
	{
		$proc_name = $context->getProcedureName();

		log_info( "system",  "ץ[$proc_name]¹Ԥޤ", __FILE__, __LINE__ );

		//=======================================
		// ϥե륿μ¹
		//
		log_info( "system",  "ϥե륿¹Ԥޤ", __FILE__, __LINE__ );

		if ( $this->_input_filters ) {
			foreach( $this->_input_filters as $filter_name ) {
				// ե륿
				$filter = charcoal_FilterFactory::create( $filter_name );
				// ե륿μ¹
				$filter->filter( $request, $context, $response );
			}
		}

		log_info( "system",  "ϥե륿¹Ԥޤ", __FILE__, __LINE__ );

		//=======================================
		// ModuleGraphι
		//
		log_info( "system",  "⥸塼륰դιۤԤޤ", __FILE__, __LINE__ );

		// ץ̾
		$proc_name = $context->getProcedureName();

		// եɤ߹
		$module_graph_config = 	charcoal_ConfigLoader::loadConfig( $proc_name, 'module_graph' );

		// ModuleGraphȤΩƤ
		$module_graph = new charcoal_ModuleGraph();
		$module_graph->build( $module_graph_config, $context );

		log_info( "system",  "⥸塼륰դιۤλޤ", __FILE__, __LINE__ );

		//=======================================
		// ModuleGraphμ¹
		//
		log_info( "system",  "⥸塼륰դμ¹Ԥ򳫻Ϥޤ", __FILE__, __LINE__ );

		// ⥸塼륰դΥȥΡɤstartΡɤ
		$module_graph->start();

		// ModuleGraph¹Ԥ
		while ( $module_graph->hasCurrentNode() )
		{
			// ߤΥΡ
			$node = $module_graph->getCurrentNode();
			$node_name = $node->getNodeName();

			// Ρɤ¹Ԥ
			$transition_key = $node->execute( $request, $context, $response );

			log_info( "system",  "ΥΡɤܥ[$transition_key]Ǥ", __FILE__, __LINE__ );

			// ΥΡ
			$next_node = $node->getNextNode( $transition_key );

			log_info( "system",  "ΥΡ̾[$next_node]Ǥ", __FILE__, __LINE__ );

			// 褬ʤХǥե
			if ( $next_node == NULL ){
				log_info( "system",  "[$transition_key]Ƥʤᡢܤޤ", __FILE__, __LINE__ );
				$transition_key = 'default';
			}

			// ΥΡɤ˰ư
			$node = $module_graph->moveNext( $transition_key );

			// ܥNULLʤнλ
			if ( $node == NULL ){
				log_info( "system",  "ܤλޤ", __FILE__, __LINE__ );
				break;
			}

			$next_node_name = $node->getNodeName();
			log_info( "system",  "Ρ[$node_name]Ρ[$next_node_name]ܤޤ", __FILE__, __LINE__ );
		}


		log_info( "system",  "⥸塼륰դμ¹Ԥλޤ", __FILE__, __LINE__ );

		//=======================================
		// ϥե륿μ¹
		//
		log_info( "system",  "ϥե륿¹Ԥޤ", __FILE__, __LINE__ );

		if ( $this->_output_filters ) {
			foreach( $this->_output_filters as $filter_name ) {
				// ե륿
				$filter = charcoal_FilterFactory::create( $filter_name );
				// ե륿μ¹
				$filter->filter( $request, $context, $response );
			}
		}

		log_info( "system",  "ϥե륿¹Ԥޤ", __FILE__, __LINE__ );

		//=======================================
		// μ¹
		//

		log_info( "system",  "¹Ԥޤ", __FILE__, __LINE__ );

		if ( $this->_renderer && strlen($this->_renderer) > 0 ) {
			$renderer = charcoal_RendererFactory::create( $this->_renderer );
			if ( $renderer ) {
				$renderer->render( $proc_name, $context, $response );
			}
		}

		log_info( "system",  "¹Ԥޤ", __FILE__, __LINE__ );

		log_info( "system",  "ץ[$proc_name]¹Ԥޤ", __FILE__, __LINE__ );
	}
}
